//+------------------------------------------------------------------+ 
//| HMA.mq4 
//| Copyright ? 2006 WizardSerg <wizardserg@mail.ru>, ?? ??????? ForexMagazine #104 
//| wizardserg@mail.ru 
//| Revised by IgorAD,igorad2003@yahoo.co.uk | 
//| Personalized by iGoR AKA FXiGoR for the Trend Slope Trading method (T_S_T) 
//| Link: 
//| contact: thefuturemaster@hotmail.com 
//+------------------------------------------------------------------+
#property copyright "MT4 release WizardSerg <wizardserg@mail.ru>, ?? ??????? ForexMagazine #104" 
#property link "wizardserg@mail.ru" 

#property indicator_chart_window 
#property indicator_buffers 3 
#property indicator_color2 Blue 
#property indicator_color3 Red 
#property indicator_color1 Orange 
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1

//---- input parameters 
extern int period=45; 
extern int method=2; // MODE_SMA 
extern int price=0; // PRICE_CLOSE
extern int EmailON=1; // 0 = false 1 = true
extern int SoundON=1; // 0 = false 1 = true
//---- buffers 
double Uptrend1[];
double Dntrend1[];
double ExtMapBuffer1[]; 
double buff1[];


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init() 
{ 
IndicatorBuffers(3); 
SetIndexBuffer(1, Uptrend1); 
//ArraySetAsSeries(Uptrend1, true); 
SetIndexBuffer(2, Dntrend1); 
//ArraySetAsSeries(Dntrend1, true); 
//SetIndexBuffer(2, ExtMapBuffer1); 
//ArraySetAsSeries(Uptrend1, true);
SetIndexBuffer(0, ExtMapBuffer1); 
ArraySetAsSeries(ExtMapBuffer1, true); 

SetIndexStyle(0,DRAW_LINE);
SetIndexStyle(1,DRAW_LINE);
SetIndexStyle(2,DRAW_LINE);

IndicatorShortName("Slope Direction Line1("+period+")"); 
return(0); 
} 

//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function | 
//+------------------------------------------------------------------+ 
int deinit() 
{ 
// ???? ????? ?????? ?????? 
return(0); 
} 

//+------------------------------------------------------------------+ 
//| ?????????? ??????? | 
//+------------------------------------------------------------------+ 
double WMA(int x, int p) 
{ 
return(iMA(NULL, 0, p, 0, method, price, x)); 
} 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function | 
//+------------------------------------------------------------------+ 
int start() 
{ 
int counted_bars = IndicatorCounted(); 

if(counted_bars < 0) 
return(-1); 

int x = 0; 
int p = MathSqrt(period); 
int e = Bars - counted_bars + period + 1; 

double vect1[], trend1[]; 

if(e > Bars) 
e = Bars; 

ArrayResize(vect1, e); 
ArraySetAsSeries(vect1, true);
ArrayResize(trend1, e); 
ArraySetAsSeries(trend1, true); 

for(x = 0; x < e; x++) 
{ 
vect1[x] = 2*WMA(x, period/2) - WMA(x, period); 
// Print("Bar date/time: ", TimeToStr(Time[x]), " close: ", Close[x], " vect1[", x, "] = ", vect1[x], " 2*WMA(p/2) = ", 2*WMA(x, period/2), " WMA(p) = ", WMA(x, period)); 
} 

for(x = 0; x < e-period; x++)

ExtMapBuffer1[x] = iMAOnArray(vect1, 0, p, 0, method, x); 

for(x = e-period; x >= 0; x--)
{ 
trend1[x] = trend1[x+1];
if (ExtMapBuffer1[x]> ExtMapBuffer1[x+1]) trend1[x] =1;
if (ExtMapBuffer1[x]< ExtMapBuffer1[x+1]) trend1[x] =-1;

if (trend1[x]>0)
{ Uptrend1[x] = ExtMapBuffer1[x]; 
if (trend1[x+1]<0) Uptrend1[x+1]=ExtMapBuffer1[x+1];
Dntrend1[x] = EMPTY_VALUE;
}
else 
if (trend1[x]<0)
{ 
Dntrend1[x] = ExtMapBuffer1[x]; 
if (trend1[x+1]>0) Dntrend1[x+1]=ExtMapBuffer1[x+1];
Uptrend1[x] = EMPTY_VALUE;
} 
buff1[x] = trend1[x]; 

}

if (isNewBar())
{ 

if (Dntrend1[0] != 2147483647 && Uptrend1[0] == 2147483647 && Uptrend1[1] == 2147483647 && Uptrend1[2] != 2147483647)
{ 
if (SoundON==1) Alert("SELL signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime() )," Symbol=",Symbol()," Period=",Period());
if (EmailON==1) SendMail("SELL signal alert","SELL signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime() )+" Symbol="+Symbol()+" Period="+Period());
} 

if (Uptrend1[0] != 2147483647 && Dntrend1[0] == 2147483647 && Dntrend1[1] == 2147483647 && Dntrend1[2] != 2147483647)
{ 
if (SoundON==1) Alert("Buy signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime() )," Symbol=",Symbol()," Period=",Period());
if (EmailON==1) SendMail("Buy signal alert","Buy signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime() )+" Symbol="+Symbol()+" Period="+Period());
}

} 



}

bool isNewBar()
{
// Alert("in is newwwwwwwwwwwww");
static datetime lastbar=0;
datetime curbar = Time[0];

if(lastbar!=curbar)
{
lastbar=curbar;

return (true);
}
else
{

return(false);
}
} 

//+------------------------------------------------------------------+ 

